var wikiProp = [];
var wikiCat = [];
var checkedProp = [];
var checkedCat = [];
var dataElements = [];
$( window ).load(function() {
        loadCategories();
loadProperties();
    });



function loadCategories() {
    $.ajax({
        url: mw.util.wikiScript('api'),
        data: {
            action: 'query',
            list: 'allpages',
            aplimit: 1000,
            apnamespace: '14',
            format: 'json'
        },
        type: 'GET',
        success: function(data) {
            if (data && data.edit && data.edit.result == 'Success') {

            } else if (data && data.error) {
                alert(data);
            } else {
                $('#checkboxCategory').empty();
                var dataArray = data.query.allpages;
                for (var i = 0; i < dataArray.length; i++) {
                    var dataEntry = {
                        label: dataArray[i].title.replace('Category:',''),
                        id: dataArray[i].pageid,
                        className: 'Category'
                    }
                    wikiCat.push(dataEntry);
                    $('#checkboxCategory').append('<option value="' + dataEntry.label + '">' + dataEntry.label + "</option>");
                    //<option value="WY">Wyoming</option>
                    
                }
                $("#checkboxCategory").select2({
                    placeholder: "Select a Category"
                });
            }
        }
    });
}


function loadProperties() {
    $.ajax({
        url: mw.util.wikiScript('api'),
        data: {
            action: 'query',
            list: 'allpages',
            aplimit: 1000,
            apnamespace: '102',
            format: 'json'

        },
        type: 'GET',
        success: function(data) {
            if (data && data.edit && data.edit.result == 'Success') {

            } else if (data && data.error) {
                alert(data);
            } else {
              $('#checkboxProperty').empty();
                var dataArray = data.query.allpages;
                for (var i = 0; i < dataArray.length; i++) {
                    var dataEntry = {
                        label: dataArray[i].title.replace('Property:',''),
                        id: dataArray[i].pageid,
                        className: 'Property'
                    }
                    wikiProp.push(dataEntry);
                    $('#checkboxProperty').append('<option value="' + dataEntry.label + '">' + dataEntry.label + "</option>");                
                }    
                $("#checkboxProperty").select2({
                    placeholder: "Select a Property"
                });
            }
        }
    });
}

function loadSelection() {
    //Lade diese Properties
    var request = '';
 //   var checkboxes = $('#checkboxCategory > input:checkbox[name=type]:checked :checked');
  //  for (var i = 0; i < checkboxes.length; i++) {
  //      request += '[[' + checkboxes[i] + ']]';
  //  }
    var k = 0;
    $("#checkboxCategory > :checked").each(function(){
        if (k != 0) {
            request += ' OR '
        }
        request += '[[Category:' + $(this).val() + ']]';
        k++;
        checkedCat.push($(this).val());
    });

    $("#checkboxProperty > :checked").each(function(){
        request += '|?' + $(this).val();
        checkedProp.push($(this).val());
    });

    $.ajax({
        url: mw.util.wikiScript('api'),
        data: {
            format: 'json',
            action: 'ask',
            query: request
        },
        dataType: 'json',
        type: 'GET',
        success: function(data) {
            if (data && data.edit && data.edit.result == 'Success') {
                alert ('Ich bin in der Methode mit der ID ');
            } else if (data && data.error) {
                alert( 'Error: API returned error code "' + data.error.code + '": ' + data.error.info );
            } else {
                //Ich muss jetzt hier die Ergebnisse aus dem Array herausholen und entsprechend in das Ergebniss Array hineinspeichern
                //Problem ist, was wenn Werte ehrfach von einem Property benutzt werden?...soll ich dann einfach die Summe nehmen?..oder den ersten als repräsentant?
                var elements = data.query.results;
                if (ObjectLength(elements) > 0) {
                    //['Patient Claudia', 'Spitzfußprophylaxe < 15 Min.', 'Therapie', 'Economy', 'Arzt Darko', 9, 613.24],
                    var elemData = [];
                    for (var key in elements) {
                        
                        // skip loop if the property is from prototype
                        if (!elements.hasOwnProperty(key)) continue;

                        var obj = elements[key].printouts;
                        var info = new Information("Wiki Page");
                        info.addValueToInformation(elements[key].fulltext);
                        var line = new Line();
                        line.addInformationToLine(info);
                        var unit = false;
                        for (var prop in obj) {
                            // skip loop if the property is from prototype
                            if(!obj.hasOwnProperty(prop)) continue;

                            //Hier die verschiedenen Fälle abfangen

                            //Quantity ist im object --> obj[prop][i].value
                            if (obj[prop][0] !== null && typeof obj[prop][0] === 'object') {
                                for (var prop2 in obj[prop]) {
                                    if (obj[prop][prop2].hasOwnProperty('fulltext')) {
                                        //Ist Page
                                        if (!unit) {
                                            var info = new Information(obj[prop].label);
                                        }
                                        info.addValueToInformation(obj[prop][prop2]['fulltext']);
                                    } else if (obj[prop][prop2].hasOwnProperty('value')) {
                                        //Ist Quantity
                                        if (!unit) {
                                            var info = new Information(obj[prop].label + "__?" +obj[prop][prop2]['unit']);
                                            unit = true; 
                                        }
                                        info.addValueToInformation(obj[prop][prop2]['value']);
                                        
                                    } else {
                                     //   alert('Error in object ' + obj[prop][prop2]);
                                    }
                                }
                                unit = false;
                            } else {
                                //Number und Text sind direkt im Array --> obj[prop] 
                                info = new Information(obj[prop].label);
                             //   for (var i = 0; i < obj[prop].length; i++) {
                             //       info.addValueToInformation(obj[prop][i]);
                             //   }    
                                for (var prop2 in obj[prop]) {
                                    if (!isNaN(prop2)) {
                                        info.addValueToInformation(obj[prop][prop2]);
                                    }
                                }    

                            }

                            line.addInformationToLine(info);
                            //Page ist im object --> obj[prop][i].fulltext


                            //Alle werte in Information abspeichern (ist ein Array) (neues info jeweils erstellen)
                            //Und Information wiederrum in Line hinzufügen
                            //das muss nicht neu erstellt werden --> line.addInformationToLine(info);


                        }
                        //dataElements.push(objElem);
                        
                        //Füge eine 1 hinzu um Anzahl an Wiki pages zu zählen
                        info = new Information("# WikiPage");
                        info.addValueToInformation(1);
                        line.addInformationToLine(info);


                        //elemData ist das Array, dataElements die gesamten Daten einer Zeile
                        //jetzt jede Spalte durchgehen, schauen ob String und mehr als 1 element, falls ja, dann auch Anzahl hinzufügen und zusätzlich die dinger verbinden
                        //Falls Zahl und mehrere Einträge, dann summe
                        
                        elemData.push(line);
                        
                        //WICHTIG!!
                        //dataElements.push(elemData);

                    }
                    defineConfigFile(elemData);
                } else {
                    //Error
                    bootbox.dialog({
                      message: "No results were received by your Query.<br/><br/>" + request,
                      title: "Error in Query",
                      buttons: {
                        main: {
                          label: "Ok",
                          className: "btn-primary",
                          callback: function() {
                            $('#main').fadeOut(500);
                            $('#splashscreen').show(); 
                          }
                        }
                      }
                    });
                }
                    

            }
        },

         
        error: function(xhr) {
            //alert( 'Error: Request failed.' );
        }
    });
}

function defineConfigFile(elemData) {
    var fields = [];
    var data = [];
    var rows = [];
    var dataFieldNr = 0;
    var dataElements = [];
    for (var i = 0; i < elemData.length; i++) {
        dataElements.push([]);
    }
    for (var i = 0; i < elemData[0].lineArray.length; i++) {
        var arraySize = 0;
        var text_number = 0;
        //-1 --> text
        //1 --> number
        //2 --> both
        
        for (var j = 0; j < elemData.length; j++) {
            //Check Array Size and if Text or Number
            if (elemData[j].lineArray[i].valArray.length > arraySize) {
                arraySize = elemData[j].lineArray[i].valArray.length;
            }
            for (var k = 0; k < elemData[j].lineArray[i].valArray.length; k++) {
                if (isNumber(elemData[j].lineArray[i].valArray[k])) {
                    //Ist eine Zahl
                    if (text_number == -1) {
                        text_number = 2;
                    } else if (text_number == 0) {
                        text_number = 1;
                    }
                } else {
                    //Ist ein Text
                    if (text_number == 1) {
                        text_number = 2;
                    } else if (text_number == 0) {
                        text_number = -1;
                    }
                }
            }

        }

        for (var j = 0; j < elemData.length; j++) {
            if (j == 0) {
                var obj = {};
                obj.name = dataFieldNr;
                dataFieldNr++;
                if (text_number == -1) {
                    obj.caption = elemData[j].lineArray[i].property;
                    
                    if (rows.length == 0) {
                        rows.push(obj.caption);
                    }
                } else if (text_number == 1) {
                    
                    if (elemData[j].lineArray[i].property.indexOf('__?') > -1) {
                        obj.caption = elemData[j].lineArray[i].property.split('__?')[0];
                        var dataSettings = {};
                        dataSettings.aggregateFunc = 'sum';
                        if (elemData[j].lineArray[i].property.split('__?')[1] == 'KG') {
                            dataSettings.aggregateFuncName = 'sum in KG';
                            dataSettings.formatFunc = function(value) {
                                return value ? Number(value).toFixed(0) + ' KG' : '';
                            }
                        } else if (elemData[j].lineArray[i].property.split('__?')[1] =="EUR") {
                            dataSettings.aggregateFuncName = 'sum in EUR';
                            dataSettings.formatFunc = function(value) {
                                return value ? Number(value).toFixed(0) + ' €' : '';
                            }
                        } else if (elemData[j].lineArray[i].property.split('__?')[1] =="ml") {
                            dataSettings.aggregateFuncName = 'sum in ml';
                            dataSettings.formatFunc = function(value) {
                                return value ? Number(value).toFixed(0) + ' ml' : '';
                            }
                        }

                        obj.dataSettings = dataSettings;
                    } else {
                        obj.caption = elemData[j].lineArray[i].property;
                        obj.aggregateFunc = 'sum';
                    }    
                    if (data.length == 0) {
                        data.push(obj.caption);  
                    }
                    
                }
                

                fields.push(obj);

            }
            if (text_number == 1 && arraySize == 1) {
                dataElements[j].push(parseFloat(elemData[j].lineArray[i].valArray[0]));
            } else if (text_number == -1 && arraySize > 1) {
                var str = '';
                for (var v = 0; v < elemData[j].lineArray[i].valArray.length; v++) {
                    if (v != 0) {
                        str = str + ' & ';
                    }
                    str = str + elemData[j].lineArray[i].valArray[v];
                }
                dataElements[j].push(str);
                //Und adde size des Arrays
                dataElements[j].push(parseFloat(elemData[j].lineArray[i].valArray.length));
                if (j == 0) {
                    var obj2 = {};
                    obj2.name = dataFieldNr;
                    dataFieldNr++;
                    obj2.caption = '# ' + elemData[j].lineArray[i].property;
                    obj2.aggregateFunc = 'sum';

                    if (data.length == 0) {
                        data.push(obj2.caption);  
                    }
                    fields.push(obj2);
                }    
            } else if (text_number == -1 && arraySize == 1) {
                dataElements[j].push(elemData[j].lineArray[i].valArray[0]);
            } else if (text_number == 1 && arraySize > 1) {
                var str = 0;
                for (var v = 0; v < elemData[j].lineArray[i].valArray.length; v++) {
                    str = str + parseFloat(elemData[j].lineArray[i].valArray[v]);
                }
                dataElements[j].push(str);
                //Und adde size des Arrays
                dataElements[j].push(parseFloat(elemData[j].lineArray[i].valArray.length));
                if (j == 0) {
                    if (elemData[j].lineArray[i].property.indexOf('__?') > -1) {
                        var obj2 = {};
                        obj2.name = dataFieldNr;
                        dataFieldNr++;
                        obj2.caption = '# ' + elemData[j].lineArray[i].property.split('__?')[0];
                        obj2.aggregateFunc = 'sum';

                        if (data.length == 0) {
                            data.push(obj2.caption);  
                        }
                        fields.push(obj2); 
                    } else {
                        var obj2 = {};
                        obj2.name = dataFieldNr;
                        dataFieldNr++;
                        obj2.caption = '# ' + elemData[j].lineArray[i].property;
                        obj2.aggregateFunc = 'sum';

                        if (data.length == 0) {
                            data.push(obj2.caption);  
                        }
                        fields.push(obj2);    
                    }    
                    
                }
            }
        }    
        

        
    }
    
    config.fields = fields;
    config.data = data;
    config.rows = rows;
    config.dataSource = dataElements;

    //Zerstöre rr und baue neu auf
    $('#rr').remove();
    var elem = document.createElement("div");
    elem.style.padding ='7px';
    elem.id = 'rr';
    document.getElementById('main').appendChild(elem);
    
    var pgridwidget = new orb.pgridwidget(config);
    pgridwidget.render(elem);
    /*fields: [
            {
                name: '6',
                caption: 'Preis',
                dataSettings: {
                    aggregateFunc: 'sum',
                    aggregateFuncName: 'whatever',
                    formatFunc: function(value) {
                        return value ? Number(value).toFixed(0) + ' $' : '';
                    }
                }
            },
            {
                name: '0',
                caption: 'Patient'
            },
            {
                name: '1',
                caption: 'Leistung',
            },
            {
                name: '2',
                caption: 'Kategorie',
                sort: {
                    order: 'asc'
                },
                rowSettings: {
                    subTotal: {
                        visible: false,
                        collapsed: true,
                        collapsible: true
                    }
                },
            },
            {
                name: '3',
                caption: 'Klasse'
            },
            {
                name: '4',
                caption: 'Arzt',
                sort: {
                    order: 'desc'
                }
            },
            {
                name: '5',
                caption: 'Menge',
                aggregateFunc: 'sum'
            }
        ],
        rows    : [ 'Arzt'],//, 'Category' ],
        columns : [ 'Leistung'],
        data    : [ 'Menge'],
        /*preFilters : {
            'Class': { 'Matches': 'Regular' },
            'Manufacturer': { 'Matches': /^a|^c/ },
            'Category'    : { 'Does Not Match': 'D' },
           // 'Amount'      : { '>':  40 },
         //   'Quantity'    : [4, 8, 12]
        }*/
}

function checkIfNumber(array, m) {

    for (var i = 0; i < array.length; i++) {
        if(array[i][m] !== undefined && !isNumber(array[i][m])) {
            return false;
        }
    
    }        
    return true;
    
}

function isNumber (o) {
  return ! isNaN (o-0) && o != null;
}

function ObjectLength( object ) {
    var length = 0;
    for( var key in object ) {
        if( object.hasOwnProperty(key) ) {
            ++length;
        }
    }
    return length;
};

/**
 * 
 * Information Class
 *
 **/
function Information(property) {
    this.valArray = [];
    this.property = property;
} 

Information.prototype.addValueToInformation = function(value) {
    this.valArray.push(value);
};

Information.prototype.isNumber = function() {
    return ! isNaN (o-0) && o != null;
};


/**
 * 
 * Line Class
 *
 **/
function Line() {
    this.lineArray = [];
}

Line.prototype.addInformationToLine = function(information) {
    this.lineArray.push(information);
};
